var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var Base64;
(function (Base64) {
    // constants
    var b64chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var b64tab = (function (bin) {
        var t = {};
        for (var i = 0, l = bin.length; i < l; i++)
            t[bin.charAt(i)] = i;
        return t;
    })(b64chars);
    var fromCharCode = String.fromCharCode;
    // encoder stuff
    var cb_utob = function (c) {
        if (c.length < 2) {
            var cc = c.charCodeAt(0);
            return cc < 0x80
                ? c
                : cc < 0x800
                    ? fromCharCode(0xc0 | (cc >>> 6)) + fromCharCode(0x80 | (cc & 0x3f))
                    : fromCharCode(0xe0 | ((cc >>> 12) & 0x0f)) +
                        fromCharCode(0x80 | ((cc >>> 6) & 0x3f)) +
                        fromCharCode(0x80 | (cc & 0x3f));
        }
        else {
            var cc1 = 0x10000 +
                (c.charCodeAt(0) - 0xd800) * 0x400 +
                (c.charCodeAt(1) - 0xdc00);
            return (fromCharCode(0xf0 | ((cc1 >>> 18) & 0x07)) +
                fromCharCode(0x80 | ((cc1 >>> 12) & 0x3f)) +
                fromCharCode(0x80 | ((cc1 >>> 6) & 0x3f)) +
                fromCharCode(0x80 | (cc1 & 0x3f)));
        }
    };
    var re_utob = /[\uD800-\uDBFF][\uDC00-\uDFFFF]|[^\x00-\x7F]/g;
    var utob = function (u) {
        return u.replace(re_utob, cb_utob);
    };
    var cb_encode = function (ccc) {
        var padlen = [0, 2, 1][ccc.length % 3], ord = (ccc.charCodeAt(0) << 16) |
            ((ccc.length > 1 ? ccc.charCodeAt(1) : 0) << 8) |
            (ccc.length > 2 ? ccc.charCodeAt(2) : 0), chars = [
            b64chars.charAt(ord >>> 18),
            b64chars.charAt((ord >>> 12) & 63),
            padlen >= 2 ? "=" : b64chars.charAt((ord >>> 6) & 63),
            padlen >= 1 ? "=" : b64chars.charAt(ord & 63),
        ];
        return chars.join("");
    };
    var btoa = global.btoa
        ? function (b) {
            return global.btoa(b);
        }
        : function (b) {
            return b.replace(/[\s\S]{1,3}/g, cb_encode);
        };
    var _encode = function (u) {
        var isUint8Array = Object.prototype.toString.call(u) === "[object Uint8Array]";
        return isUint8Array ? u.toString("base64") : btoa(utob(String(u)));
    };
    Base64.encode = function (u, urisafe) {
        if (urisafe === void 0) { urisafe = false; }
        return !urisafe
            ? _encode(u)
            : _encode(String(u))
                .replace(/[+\/]/g, function (m0) {
                return m0 == "+" ? "-" : "_";
            })
                .replace(/=/g, "");
    };
    var encodeURI = function (u) {
        return Base64.encode(u, true);
    };
    // decoder stuff
    var re_btou = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;
    var cb_btou = function (cccc) {
        switch (cccc.length) {
            case 4:
                var cp = ((0x07 & cccc.charCodeAt(0)) << 18) |
                    ((0x3f & cccc.charCodeAt(1)) << 12) |
                    ((0x3f & cccc.charCodeAt(2)) << 6) |
                    (0x3f & cccc.charCodeAt(3)), offset = cp - 0x10000;
                return (fromCharCode((offset >>> 10) + 0xd800) +
                    fromCharCode((offset & 0x3ff) + 0xdc00));
            case 3:
                return fromCharCode(((0x0f & cccc.charCodeAt(0)) << 12) |
                    ((0x3f & cccc.charCodeAt(1)) << 6) |
                    (0x3f & cccc.charCodeAt(2)));
            default:
                return fromCharCode(((0x1f & cccc.charCodeAt(0)) << 6) | (0x3f & cccc.charCodeAt(1)));
        }
    };
    var btou = function (b) {
        return b.replace(re_btou, cb_btou);
    };
    var cb_decode = function (cccc) {
        var len = cccc.length, padlen = len % 4, n = (len > 0 ? b64tab[cccc.charAt(0)] << 18 : 0) |
            (len > 1 ? b64tab[cccc.charAt(1)] << 12 : 0) |
            (len > 2 ? b64tab[cccc.charAt(2)] << 6 : 0) |
            (len > 3 ? b64tab[cccc.charAt(3)] : 0), chars = [
            fromCharCode(n >>> 16),
            fromCharCode((n >>> 8) & 0xff),
            fromCharCode(n & 0xff),
        ];
        chars.length -= [0, 0, 2, 1][padlen];
        return chars.join("");
    };
    var _atob = global.atob
        ? function (a) {
            return global.atob(a);
        }
        : function (a) {
            return a.replace(/\S{1,4}/g, cb_decode);
        };
    var atob = function (a) {
        return _atob(String(a).replace(/[^A-Za-z0-9\+\/]/g, ""));
    };
    var _decode = function (a) {
        return btou(_atob(a));
    };
    Base64.decode = function (a) {
        return _decode(String(a)
            .replace(/[-_]/g, function (m0) {
            return m0 == "-" ? "+" : "/";
        })
            .replace(/[^A-Za-z0-9\+\/]/g, ""));
    };
})(Base64 || (Base64 = {}));
var QFQNative;
(function (QFQNative) {
    var core;
    (function (core) {
        core.AdCallbackQueue = {};
        // 2020.8.11 新增sdk 改版回调
        core.VideoAdCallbackQueue = {};
        var NativeCallQueue = {};
        var NativeCallAction = "qfqSendToNative";
        var NativeLisCallAction = "qfqActiveSendToJS";
        var NativeLisRecvAction = "qfqPassiveSendToJS";
        function parseVipcNativeMassge(serialized) {
            try {
                return JSON.parse(Base64.decode(serialized));
            }
            catch (e) {
                log("Error when parsing native params", e);
                return {};
            }
        }
        core.parseVipcNativeMassge = parseVipcNativeMassge;
        function log() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var ts = new Date()
                .toLocaleString("en")
                .replace(/\//g, "-")
                .replace(",", "");
            var prefix = "[QFQNative]";
            console.log(ts + " " + prefix + " \n " + args.slice().join(" "));
        }
        core.log = log;
        function listenActiveCallback() {
            egret.ExternalInterface.addCallback(NativeLisCallAction, function (msg) {
                var parsed = parseVipcNativeMassge(msg);
                if (NativeCallQueue[parsed.funName] && parsed.funId && NativeCallQueue[parsed.funName][parsed.funId]) {
                    // console.log("Executing native callback: ", parsed.funName);
                    NativeCallQueue[parsed.funName][parsed.funId](parsed.arg1);
                    delete NativeCallQueue[parsed.funName][parsed.funId];
                }
            });
        }
        core.listenActiveCallback = listenActiveCallback;
        function listenNativeInvoke() {
            egret.ExternalInterface.addCallback(NativeLisRecvAction, dispatchNativeCallback);
        }
        core.listenNativeInvoke = listenNativeInvoke;
        function dispatchNativeCallback(msg) {
            var parsed = parseVipcNativeMassge(msg);
            log("Receive passive msg from Native", JSON.stringify(parsed));
            if (parsed.funName in QFQNative.nativeLifeCycleEvent) {
                QFQNative.nativeLifeCycleEvent[parsed.funName].call(null, parsed.arg1, parsed.arg2, parsed.arg3, parsed.arg4);
                return;
            }
            if (window[parsed.funName]) {
                window[parsed.funName].call(null, parsed.arg1, parsed.arg2, parsed.arg3, parsed.arg4);
                return;
            }
            if (!QFQNative.QFQ2019[parsed.funName] &&
                typeof QFQNative.QFQ2019[parsed.funName] !== "function")
                return;
            QFQNative.QFQ2019[parsed.funName].call(null, parsed.arg1, parsed.arg2, parsed.arg3, parsed.arg4);
        }
        core.dispatchNativeCallback = dispatchNativeCallback;
        function callNativeFunction(ns, fn) {
            var args = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                args[_i - 2] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var fnUID, options, serializeJson, serializeBase64;
                return __generator(this, function (_a) {
                    fnUID = QFQNative.genUID();
                    options = {
                        nameSpace: ns,
                        funName: fn,
                        funId: fnUID
                    };
                    if (args && args.length) {
                        args.forEach(function (item, ind) {
                            options["arg" + (ind + 1)] = item;
                        });
                    }
                    serializeJson = JSON.stringify(options);
                    serializeBase64 = Base64.encode(serializeJson);
                    log("Calling native function", fnUID, fn, serializeJson);
                    // log("Calling native function with uid:", uid);
                    // log("Json:", serializeJson);
                    // log("Base64:", serializeBase64);
                    egret.ExternalInterface.call(NativeCallAction, serializeBase64);
                    if (!NativeCallQueue[fn])
                        NativeCallQueue[fn] = {};
                    return [2 /*return*/, new Promise(function (r) { return NativeCallQueue[fn][fnUID] = r; })];
                });
            });
        }
        core.callNativeFunction = callNativeFunction;
        var _nativeInfoResolver;
        var _nativeInfo;
        function nativeInfo() {
            if (_nativeInfo) {
                return Promise.resolve(_nativeInfo);
            }
            else {
                return new Promise(function (resolve) { return (_nativeInfoResolver = resolve); });
            }
        }
        core.nativeInfo = nativeInfo;
        function init() {
            return __awaiter(this, void 0, void 0, function () {
                var signInfo, memberId, fromUrl, sdkVersionNum, apkVersionNum;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            core.listenActiveCallback();
                            core.listenNativeInvoke();
                            return [4 /*yield*/, QFQNative.QFQ2019.sign()];
                        case 1:
                            signInfo = _a.sent();
                            return [4 /*yield*/, QFQNative.QFQ2019.getMemberId()];
                        case 2:
                            memberId = _a.sent();
                            return [4 /*yield*/, QFQNative.QFQ2019.getFromUrl()];
                        case 3:
                            fromUrl = _a.sent();
                            sdkVersionNum = signInfo._sv.replace(/-\S+$/, "").split(".").join("");
                            apkVersionNum = signInfo._av.replace(/-\S+$/, "").split(".").join("");
                            _nativeInfo = {
                                appId: signInfo._appid,
                                appVersion: signInfo._av,
                                apkVersionNum: apkVersionNum,
                                sdkVersion: signInfo._sv,
                                sdkVersionNum: sdkVersionNum,
                                channel: signInfo._ch,
                                imei: signInfo._imei,
                                imei2: signInfo._imei2,
                                memberId: memberId,
                                fromUrl: fromUrl,
                            };
                            if (_nativeInfoResolver) {
                                _nativeInfoResolver(_nativeInfo);
                                _nativeInfoResolver = null;
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
        core.init = init;
        function addAdCallback(fn) {
            core.AdCallbackQueue[QFQNative.genUID()] = fn;
        }
        core.addAdCallback = addAdCallback;
        function addVideoAdCallback(fn) {
            core.VideoAdCallbackQueue[QFQNative.genUID()] = fn;
        }
        core.addVideoAdCallback = addVideoAdCallback;
    })(core = QFQNative.core || (QFQNative.core = {}));
})(QFQNative || (QFQNative = {}));
var QFQNative;
(function (QFQNative) {
    var ns = 'QFQ2019';
    QFQNative.sdkMethods = [
        "bindWechat",
        "getFromUrl",
        "writeData",
        "readData",
        "getToken",
        "openPopWindow",
        "popWindowBtnOnClick",
        "popWindowClose",
        "popWindowFinish",
        "getMemberId",
        "getNotchBarHeight",
        "showAdvertView",
        "showAdverView2",
        "closeAdvertView",
        "closeAdvertView2",
        "onKeyBackPress",
        "openWechatMicrApp",
        "onLoadGameFinished",
        "getDeviceInfo",
        "checkUpdate",
        "getLocationAddress",
        "autoClickPos",
        "showPodAd",
        "openFullVideoAd",
        "openVideoAd",
        "popV3WindowFinish",
        "track",
        "showToastWithType",
        "getUserRegisterDay",
        "getAdConfig",
    ];
    var wrapper = {};
    QFQNative.sdkMethods.map(function (method) {
        wrapper[method] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, QFQNative.core.callNativeFunction.apply(QFQNative.core, ["QFQ2019", method].concat(args))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
    });
    QFQNative.QFQ2019 = __assign({}, wrapper, { sign: function (opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            _b = (_a = JSON).parse;
                            return [4 /*yield*/, QFQNative.core.callNativeFunction(ns, 'sign', opts)];
                        case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
                    }
                });
            });
        },
        openActivity: function (activityName, opts) {
            return QFQNative.core.callNativeFunction(ns, 'openActivity', activityName, opts);
        },
        openInnerUrl: function (url, opts) {
            return QFQNative.core.callNativeFunction(ns, 'openInnerUrl', url, opts);
        },
        openWebModuleWithType: function (type, url, opts) {
            if (type === void 0) { type = 0; }
            return QFQNative.core.callNativeFunction(ns, 'openWebModuleWithType', type, url, opts);
        },
        openOuterUrl: function (url, opts) {
            return QFQNative.core.callNativeFunction(ns, 'openOuterUrl', url, opts);
        },
        openXqActivity: function (opts) {
            return QFQNative.core.callNativeFunction(ns, 'openXqActivity', JSON.stringify(opts));
        },
        openDyActivity: function (opts) {
            return QFQNative.core.callNativeFunction(ns, 'openDyActivity', JSON.stringify(opts));
        },
        openPopV3Window: function (opts) {
            return QFQNative.core.callNativeFunction(ns, 'openPopV3Window', JSON.stringify(opts));
        },
        getVideoCountWithType: function (type) {
            return QFQNative.core.callNativeFunction(ns, 'getVideoCountWithType', type);
        },
        loadIntAd: function (adSizeType, adCode, launchActivity) {
            return QFQNative.core.callNativeFunction(ns, 'loadIntAd', adSizeType, adCode, launchActivity);
        },
        cacheFeed: function (adcode) {
            return QFQNative.core.callNativeFunction(ns, 'cacheFeed', adcode);
        },
        cacheFullscreen: function (adcode) {
            return QFQNative.core.callNativeFunction(ns, 'cacheFullscreen', adcode);
        },
        cacheInteraction: function (adcode) {
            return QFQNative.core.callNativeFunction(ns, 'cacheInteraction', adcode);
        },
        cacheVideo: function (adcode) {
            return QFQNative.core.callNativeFunction(ns, 'cacheVideo', adcode);
        },
        track: function (event, params) {
            if (params === void 0) { params = {}; }
            return QFQNative.core.callNativeFunction(ns, 'track', event, JSON.stringify(params));
        },
        showToastWithType: function (type, message) {
            return QFQNative.core.callNativeFunction(ns, 'showToastWithType', type, message);
        },
        getUserRegisterDay: function () {
            return QFQNative.core.callNativeFunction(ns, 'getUserRegisterDay');
        } });
})(QFQNative || (QFQNative = {}));
var QFQNative;
(function (QFQNative) {
    function init(mock) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (mock) {
                            QFQNative.QFQ2019 = Object.assign({}, QFQNative.QFQ2019, mock);
                        }
                        return [4 /*yield*/, QFQNative.core.init()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    QFQNative.init = init;
    function restartGame() {
        location.reload();
    }
    QFQNative.restartGame = restartGame;
    function openInnerUrl(url, option) {
        if (option === void 0) { option = {}; }
        var ext = Object.assign({
            title: " ",
            toolbarStatus: 0,
            statusBarColor: "#F44A4C",
            hasBack: true,
            hasClose: false,
            hasInterceptBackBtn: false,
            orientation: 1,
            hasRefresh: true,
        }, option);
        QFQNative.QFQ2019.openInnerUrl(url, ext);
    }
    QFQNative.openInnerUrl = openInnerUrl;
    function openWebModuleWithType(type, url, option) {
        if (option === void 0) { option = {}; }
        var ext = Object.assign({
            buttonInfo: {
                hasRefresh: false,
                hasBack: true,
                hasClose: false,
                hasInterceptBackBtn: false,
                hasPullToRefresh: false
            },
            statusbar: {
                isPenetrable: false
            }
        }, option);
        QFQNative.QFQ2019.openWebModuleWithType(type, url, ext);
    }
    QFQNative.openWebModuleWithType = openWebModuleWithType;
    function getVideoCountWithType(type) {
        if (type === void 0) { type = 4; }
        return QFQNative.QFQ2019.getVideoCountWithType(type);
    }
    QFQNative.getVideoCountWithType = getVideoCountWithType;
    function getUserRegisterDay() {
        return QFQNative.QFQ2019.getUserRegisterDay();
    }
    QFQNative.getUserRegisterDay = getUserRegisterDay;
    function track(event, params) {
        if (params === void 0) { params = {}; }
        try {
            QFQNative.QFQ2019.track(event, params);
        }
        catch (e) {
            console.log(e);
        }
    }
    QFQNative.track = track;
    var nativeLifeCycle = {};
    QFQNative.nativeLifeCycleEvent = {
        onShow: function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b, _i, cb;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            QFQNative.core.log("Executing onshow, queue length: ", Object.keys(QFQNative.core.AdCallbackQueue).length);
                            _a = [];
                            for (_b in QFQNative.core.AdCallbackQueue)
                                _a.push(_b);
                            _i = 0;
                            _c.label = 1;
                        case 1:
                            if (!(_i < _a.length)) return [3 /*break*/, 4];
                            cb = _a[_i];
                            return [4 /*yield*/, QFQNative.core.AdCallbackQueue[cb]()];
                        case 2:
                            _c.sent();
                            delete QFQNative.core.AdCallbackQueue[cb];
                            _c.label = 3;
                        case 3:
                            _i++;
                            return [3 /*break*/, 1];
                        case 4:
                            QFQNative.core.log("callback complete, checking native life cycle: ", !!nativeLifeCycle.onShow);
                            nativeLifeCycle.onShow && nativeLifeCycle.onShow();
                            return [2 /*return*/];
                    }
                });
            });
        },
        openVideoAd: function (flag, adcode) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b, _i, cb;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            QFQNative.core.log("Executing open video ad callback, got flag: ", flag, adcode);
                            _a = [];
                            for (_b in QFQNative.core.VideoAdCallbackQueue)
                                _a.push(_b);
                            _i = 0;
                            _c.label = 1;
                        case 1:
                            if (!(_i < _a.length)) return [3 /*break*/, 4];
                            cb = _a[_i];
                            return [4 /*yield*/, QFQNative.core.VideoAdCallbackQueue[cb]({ flag: flag, adcode: adcode })];
                        case 2:
                            _c.sent();
                            delete QFQNative.core.VideoAdCallbackQueue[cb];
                            _c.label = 3;
                        case 3:
                            _i++;
                            return [3 /*break*/, 1];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        },
        onQFQInBackground: function () {
            nativeLifeCycle.onHide && nativeLifeCycle.onHide();
        },
        onKeyBackPress: function () {
            var canGoBack = true;
            if (nativeLifeCycle.onBack) {
                canGoBack = nativeLifeCycle.onBack();
            }
            if (canGoBack) {
                QFQNative.QFQ2019.onKeyBackPress(+canGoBack);
            }
        },
    };
    function setLifeCycle(lifeCycle) {
        nativeLifeCycle = Object.assign({}, nativeLifeCycle, lifeCycle);
    }
    QFQNative.setLifeCycle = setLifeCycle;
    // 广告相关
    function openVideoAd(id, type, activityName) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                QFQNative.QFQ2019.openActivity("MixAdFactoryActivity", {
                    code: id,
                    type: type || 4,
                });
                return [2 /*return*/, new Promise(function (resolve) { return QFQNative.core.addAdCallback(resolve); })];
            });
        });
    }
    QFQNative.openVideoAd = openVideoAd;
    // 广告相关
    function openVideoAdV2(code, isfull, rotatype) {
        if (isfull === void 0) { isfull = false; }
        if (rotatype === void 0) { rotatype = 0; }
        return __awaiter(this, void 0, void 0, function () {
            var nInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, QFQNative.core.nativeInfo()];
                    case 1:
                        nInfo = _a.sent();
                        if (+nInfo.sdkVersionNum >= 2330) {
                            QFQNative.QFQ2019[isfull ? "openFullVideoAd" : "openVideoAd"](code, "" + rotatype);
                        }
                        else {
                            QFQNative.QFQ2019[isfull ? "openFullVideoAd" : "openVideoAd"](code);
                        }
                        return [2 /*return*/, new Promise(function (resolve) { return QFQNative.core.addVideoAdCallback(resolve); })];
                }
            });
        });
    }
    QFQNative.openVideoAdV2 = openVideoAdV2;
    function openXiqu() {
        return __awaiter(this, void 0, void 0, function () {
            var nInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, QFQNative.core.nativeInfo()];
                    case 1:
                        nInfo = _a.sent();
                        if (+nInfo.sdkVersionNum >= 2301) {
                            QFQNative.QFQ2019.openXqActivity({
                                actionId: "9",
                            });
                        }
                        else {
                            QFQNative.QFQ2019.openActivity("QFQHiXiQuAdActivity", {
                                actionId: 9,
                            });
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    QFQNative.openXiqu = openXiqu;
    function openActivity(action) {
        return __awaiter(this, void 0, void 0, function () {
            var nInfo, setting, opt;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, QFQNative.core.nativeInfo()];
                    case 1:
                        nInfo = _a.sent();
                        setting = action.actionSetting;
                        opt = {
                            actionId: action.id,
                            taskId: action.taskId,
                        };
                        Object.assign({}, opt, setting.intent);
                        if (+nInfo.sdkVersionNum >= 1222 &&
                            setting.activity === "QFQRewardVideoAdActivity") {
                            //兼容 2020-03-25
                            setting.activity = "MixAdFactoryActivity";
                        }
                        if (+nInfo.sdkVersionNum < 1222 &&
                            setting.activity === "MixAdFactoryActivity") {
                            //兼容 2020-03-25
                            setting.activity = "QFQRewardVideoAdActivity";
                        }
                        if ("openDyActivity" in QFQNative.QFQ2019 &&
                            setting.activity === "QFQDuoYouAdActivity") {
                            QFQNative.QFQ2019.openDyActivity(opt);
                        }
                        else if ("openXqActivity" in QFQNative.QFQ2019 &&
                            setting.activity === "QFQHiXiQuAdActivity") {
                            QFQNative.QFQ2019.openXqActivity(opt);
                        }
                        else {
                            QFQNative.QFQ2019.openActivity(setting.activity, opt);
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    QFQNative.openActivity = openActivity;
    function showPodAd(code) {
        QFQNative.core.nativeInfo().then(function (nInfo) {
            if (+nInfo.sdkVersionNum >= 2000) {
                QFQNative.QFQ2019.showPodAd(code);
            }
        });
    }
    QFQNative.showPodAd = showPodAd;
    function cacheFeed(adcode) {
        if (adcode === void 0) { adcode = ''; }
        QFQNative.core.log("cacheFeed");
        QFQNative.QFQ2019.cacheFeed(adcode);
    }
    QFQNative.cacheFeed = cacheFeed;
    function cacheFullscreen(adcode) {
        if (adcode === void 0) { adcode = ''; }
        QFQNative.core.log("cacheFullscreen");
        QFQNative.QFQ2019.cacheFullscreen(adcode);
    }
    QFQNative.cacheFullscreen = cacheFullscreen;
    function cacheInteraction(adcode) {
        if (adcode === void 0) { adcode = ''; }
        QFQNative.core.log("cacheInteraction");
        QFQNative.QFQ2019.cacheInteraction(adcode);
    }
    QFQNative.cacheInteraction = cacheInteraction;
    function cacheVideo(adcode) {
        if (adcode === void 0) { adcode = ''; }
        QFQNative.core.log("cacheVideo");
        QFQNative.QFQ2019.cacheVideo(adcode);
    }
    QFQNative.cacheVideo = cacheVideo;
    function loadIntAd(code) {
        if (code === void 0) { code = ''; }
        QFQNative.core.log("loadIntAd");
        QFQNative.QFQ2019.loadIntAd('2', code, 'false');
    }
    QFQNative.loadIntAd = loadIntAd;
    function genUID() {
        return Math.random().toString(36).substring(2);
    }
    QFQNative.genUID = genUID;
    function getDeviceInfo(stageWidth) {
        return __awaiter(this, void 0, void 0, function () {
            var info, deviceInfo, notchBarHeight, screenWidth, ratio, realNotch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, QFQNative.QFQ2019.getDeviceInfo()];
                    case 1:
                        info = _a.sent();
                        deviceInfo = JSON.parse(info);
                        notchBarHeight = deviceInfo.notchBarHeight, screenWidth = deviceInfo.screenWidth;
                        ratio = stageWidth / screenWidth;
                        deviceInfo.ratio = ratio;
                        realNotch = ratio * notchBarHeight;
                        deviceInfo.realNotch = realNotch;
                        return [2 /*return*/, deviceInfo];
                }
            });
        });
    }
    QFQNative.getDeviceInfo = getDeviceInfo;
    function showAdvertView(adConfig) {
        var adCode = adConfig.adCode, x = adConfig.x, y = adConfig.y, margin = adConfig.margin;
        QFQNative.QFQ2019.showAdvertView(x + "|" + y + "|" + margin, adCode);
    }
    QFQNative.showAdvertView = showAdvertView;
    function showAdverView2(adConfig) {
        var adCode = adConfig.adCode, adtype = adConfig.adtype, x = adConfig.x, y = adConfig.y, margin = adConfig.margin;
        QFQNative.QFQ2019.showAdverView2(x + "|" + y + "|" + margin, adCode, adtype);
    }
    QFQNative.showAdverView2 = showAdverView2;
    function showToast(options) {
        QFQNative.QFQ2019.showToastWithType(options.type, options.message);
    }
    QFQNative.showToast = showToast;
    function execTask(action) {
        var actionEnum = action.action;
        var setting = action.actionSetting;
        switch (actionEnum) {
            case 1:
                QFQNative.openActivity(action);
                break;
            case 2:
                // openDialog(action);
                break;
            case 3:
                // openApp(action);
                break;
            case 4:
                // downloadApp(action, callback);
                break;
            case 5:
                // message('action=5 打开微信小程序(暂不实现)');
                break;
            case 6:
                QFQNative.openInnerUrl(setting.url, Object.assign({}, action.ext || {}, setting.ext || {}));
                break;
            case 7:
                var opt = {
                    actionId: action.id,
                    taskId: action.taskId,
                };
                QFQNative.QFQ2019.openOuterUrl(setting.url, opt);
                break;
            case 8:
                // share(action, callback);
                break;
            case 10:
                break;
            default:
                // message(`未知action${actionEnum}`);
                break;
        }
    }
    QFQNative.execTask = execTask;
    var voidFn = function () { };
    function popWindow(option) {
        return new Promise(function (resolve, reject) {
            QFQNative.QFQ2019.popWindowBtnOnClick = function (data, fromUrl) {
                QFQNative.core.log("Rcv data from pop window: " + data + " " + fromUrl);
                if (data) {
                    QFQNative.core.log("pop window data: ", data, option.closeButton && option.closeButton.data, option.topButtonInfo && option.topButtonInfo.data, option.extraButton && option.extraButton.data);
                    if (option.closeButton && option.closeButton.data && data == option.closeButton.data) {
                        option.onClose();
                    }
                    if (option.extraButton && option.extraButton.data && data == option.extraButton.data) {
                        option.onNormal();
                    }
                    if (option.topButtonInfo && option.topButtonInfo.data && data == option.topButtonInfo.data) {
                        option.onDouble();
                    }
                }
                resolve(data);
                QFQNative.QFQ2019.popWindowBtnOnClick = voidFn;
                // QFQ2019.popV3WindowFinish();
            };
            QFQNative.QFQ2019.popWindowClose = function (data, fromUrl) {
                QFQNative.core.log('popWindowClose data:', data);
                QFQNative.core.log('popWindowClose fromUrl:', fromUrl);
                if (data) {
                    if (option.extraButton && option.extraButton.data && data == option.extraButton.data) {
                        QFQNative.core.log('onNormal调用');
                        option.onNormal();
                    }
                    if (option.topButtonInfo && option.topButtonInfo.data && data == option.topButtonInfo.data) {
                        QFQNative.core.log('onDouble调用');
                        option.onDouble();
                    }
                }
                else {
                    if (option.closeButton && option.closeButton.data) {
                        QFQNative.core.log('onClose调用');
                        option.onClose();
                    }
                }
                resolve(data);
                QFQNative.QFQ2019.popWindowClose = voidFn;
            };
            option.closeButton = Object.assign({
                visible: 1,
                hasTimer: 0,
                time: 3,
            }, option.closeButton || {}, {
                data: "inherit",
            });
            if (option.topButtonInfo) {
                option.topButtonInfo = Object.assign({
                    text: "翻倍领取",
                    data: "double",
                }, option.topButtonInfo || {});
            }
            if (option.extraButton) {
                option.extraButton = Object.assign({
                    text: "单倍领取",
                    data: "normal",
                }, option.extraButton || {});
            }
            QFQNative.core.log('openPopV3Window.coinDesc:', option.coinDesc);
            QFQNative.core.log('openPopV3Window closeButton data:', option.closeButton.data);
            QFQNative.QFQ2019.openPopV3Window(Object.assign({
                fromUrl: "egret",
                title: "金币奖励",
            }, option));
        });
    }
    QFQNative.popWindow = popWindow;
})(QFQNative || (QFQNative = {}));
(function (QFQNative) {
    var Storage;
    (function (Storage) {
        function getStorageKey() {
            return __awaiter(this, void 0, void 0, function () {
                var nativeInfo;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, QFQNative.core.nativeInfo()];
                        case 1:
                            nativeInfo = _a.sent();
                            return [2 /*return*/, "QFQGAME_" + nativeInfo.appId + "_" + (nativeInfo.memberId || "mid")];
                    }
                });
            });
        }
        function readStorage() {
            return __awaiter(this, void 0, void 0, function () {
                var storageKey;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, getStorageKey()];
                        case 1:
                            storageKey = _a.sent();
                            return [2 /*return*/, QFQNative.QFQ2019.readData(storageKey).then(function (val) {
                                    if (val) {
                                        try {
                                            var objVal = JSON.parse(val);
                                            return objVal;
                                        }
                                        catch (err) {
                                            return null;
                                        }
                                    }
                                    return null;
                                })];
                    }
                });
            });
        }
        var queue = {};
        function write(key, val) {
            return __awaiter(this, void 0, void 0, function () {
                var storageKey, storageVal, newVal, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (val != "") {
                                Object.assign(queue, (_a = {},
                                    _a[key] = val,
                                    _a));
                            }
                            else if (key in queue) {
                                delete queue[key];
                            }
                            return [4 /*yield*/, getStorageKey()];
                        case 1:
                            storageKey = _b.sent();
                            return [4 /*yield*/, readStorage()];
                        case 2:
                            storageVal = (_b.sent()) || {};
                            newVal = Object.assign({}, storageVal, queue);
                            if (!val && key in newVal) {
                                delete newVal[key];
                            }
                            QFQNative.QFQ2019.writeData(storageKey, JSON.stringify(newVal));
                            return [2 /*return*/];
                    }
                });
            });
        }
        Storage.write = write;
        function read(key) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, readStorage().then(function (val) { return (val && val[key]) || null; })];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        }
        Storage.read = read;
        function remove(key) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, write(key, "")];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        }
        Storage.remove = remove;
    })(Storage = QFQNative.Storage || (QFQNative.Storage = {}));
})(QFQNative || (QFQNative = {}));
